# API Docs

The files in this directory are automatically generated from the docstrings in
the source code. They include descriptions of each of the DataJoint tables and
other classes/methods within Spyglass.

## Directories

- `cli`: See README.md at `spyglass/examples/cli/README.md`
- `common`: Data insertion point for all pipelines.
- `data_import`: Data insertion tools.
- `decoding`: Decoding animal position from spiking data.
- `figurl_views`: Tools for visualizing data.
- `lfp`: Local field potential processing.
- `lock`: Tables for locking files, preventing deletion.
- `position`: Tracking animal posisiton via LEDs ('Trodes') or DeepLabCut.
- `linearization`: Linearizing position data for decoding.
- `ripple`: Detecting ripples in LFP data.
- `sharing`: Tables for data sharing via Kachery.
- `spikesorting`: Sorting spikes from raw electrophysiology data.
- `utils`: Utilities for working with DataJoint and Neurodata Without Borders
    (NWB) data.
